<template>
  <SinglePane>
    <div class="tenders-groups">
      <div class="tenders-groups__title">
        Группы контрагентов
      </div>

      <ObTable
        class="tenders-groups__table"
        @add="openAdd"
        @select="onSelect"
        :columns="columns"
        :functional-panel="true"
        :show-add-button="true"
        :show-edit="false"
        :show-refresh="false"
        :remote-opt="{
          method: getParticipantGroups,
          contentKey: 'participantGroups'
        }"
        :is-functional-sort="false"
        :is-functional-group="false"
        ref="groupsTable"
        data-qa="groupsTable"
        is-fixed-header
      >
        <template slot="group-title" slot-scope="{ data }">
          {{ data.item.title }}

          <div v-if="data.item.description" class="group-title-description">
            {{ data.item.description }}
          </div>
        </template>

        <template slot="participant-count" slot-scope="{ data }">
          <div class="participant-count">{{ data.item.participantCount }}</div>
        </template>

        <template slot="group-date-changed" slot-scope="{ data }">
          <span>{{ new Date(data.item.lastChangedAt).toLocaleDateString() }}, </span>
          <span class="field-time">{{ new Date(data.item.lastChangedAt).toLocaleTimeString() }}</span>
        </template>

        <template slot="group-date-created" slot-scope="{ data }">
          <span>{{ new Date(data.item.createdAt).toLocaleDateString() }}, </span>
          <span class="field-time">{{ new Date(data.item.createdAt).toLocaleTimeString() }}</span>
        </template>

        <template slot="field-delete" slot-scope="{ data }">
          <ObMenuDropdown
            class="tenders-groups__row-dropdown"
            :items="dropdownTabs || [{ title: '--' }]"
            :is-arrow="false"
            data-qa="tendersGroupsDropdown"
            @to-delete="toDeleteGroup(data)"
          />
        </template>
      </ObTable>

      <ObModal
        ref="addGroup"
        title="Группа"
        title-second="Добавление"
        size="medium"
        :is-show-controls="false"
        data-qa="addGroup"
      >
        <CreateParticipantGroup @submit="onAdd" />
      </ObModal>

      <ObModal
        ref="deletionConfirmation"
        :title="`Удаление группы «${toDeleteRowData.title}»`"
        size="medium"
        :is-show-controls="false"
        data-qa="deletionConfirmation"
      >
        <DeletionConfirmation
          :data-source="toDeleteRowData"
          @delete="onDelete"
        />
      </ObModal>
    </div>
  </SinglePane>
</template>

<script>

  import CreateParticipantGroup from '../../components/Tenders/createParticipantGroup'
  import DeletionConfirmation from './modal/deletionConfirmation'

  import SinglePane from 'common-components/src/obComponents/obSinglePanels'
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
  import api from '@/api'

  export default {
    name: 'TendersAllGroupsPage',
    components: {
      ObTable,
      CreateParticipantGroup,
      DeletionConfirmation,
      ObModal,
      ObMenuDropdown,
      SinglePane
    },
    computed: {
      columns () {
        return [
          {
            title: 'Название группы',
            key: 'title',
            slotName: 'group-title'
          },
          {
            title: 'Количество контрагентов',
            key: 'participantCount',
            width: 130,
            slotName: 'participant-count',
            headerHtml: ({ title }) => this.participantCountHeader(title)
          },
          {
            title: 'Последнее изменение',
            key: 'lastChangedAt',
            slotName: 'group-date-changed'
          },
          {
            title: 'Группа создана',
            key: 'createdAt',
            slotName: 'group-date-created'
          },
          {
            title: 'Кто создал',
            key: 'creatorUuid',
            html: ({ firstName, lastName }) => this.getHtmlCreator(firstName, lastName)
          },
          {
            slotName: 'field-delete',
            width: 44,
            isToggleDisabled: true,
            action: true
          }
        ]
      }
    },
    methods: {
      toDeleteGroup (data) {
        this.toDeleteRowData = data.item

        if (data.item.participantCount === 0) {
          this.deleteGroup(data.item)
        } else {
          this.$refs.deletionConfirmation.open()
        }
      },
      onDelete (event) {
        this.deleteGroup(event)
        this.$refs.deletionConfirmation.close()
      },
      async deleteGroup (data) {
        await api.tendersContractors.deleteParticipantGroup(data.uuid)

        this.$refs.groupsTable.loadData({ init: true })

        this.$notification({
          type: 'system_notification_success',
          message: `Группа «` + data.title + '» удалена'
        })
      },
      onSelect (row) {
        this.$router.push({
          path: `/tenders-contractor-groups/${row.uuid}`
        })
      },
      onAdd () {
        this.$refs.groupsTable.loadData({ init: true })
        this.$refs.addGroup.close()
      },
      openAdd () {
        this.$refs.addGroup.open()
      },
      participantCountHeader (title) {
        return `<div class="participant-count-header">${title}</div>`
      },
      getHtmlCreator (firstName, lastName) {
        return `${firstName} ${lastName}`
      },
      async getParticipantGroups (params) {
        return await api.tendersContractors.getParticipantGroups(params)
      }
    },
    data () {
      return {
        formData: [],
        toDeleteRowData: {},
        dropdownTabs: [
          {
            title: 'Удалить группу',
            event: 'to-delete'
          }
        ]
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';
  .tenders-groups {
    &__row-dropdown {
      visibility: hidden;
    }

    &__table tr:hover &__row-dropdown {
      visibility: visible;
    }

    &__title {
      @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);

      padding: 20px;
    }
  }

  .field-time {
    color: $color-grey-span;
  }

  .group-title-description {
    color: $color-grey-span;
  }

  ::v-deep .participant-count-header {
    width: 130px;
    text-align: right;
  }

  .participant-count {
    width: 130px;
    text-align: right;
  }
</style>
